<?php

/* * ********************************************************************
 * ProxmoxAddon product developed. (Oct 1, 2018)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

namespace ModulesGarden\ProxmoxAddon\App\UI\NodeDetail\Pages;

use ModulesGarden\ProxmoxAddon as main;
use ModulesGarden\ProxmoxAddon\Core\UI\Interfaces\AdminArea;
use ModulesGarden\ProxmoxAddon\Core\UI\Widget\Forms\Fields\Select;
use ModulesGarden\ProxmoxAddon\Core\UI\Widget\Graphs\Line;
use ModulesGarden\ProxmoxAddon\Core\UI\Widget\Graphs\Models\DataSet;

class MemoryGraph extends Line implements AdminArea
{

    use LoadAPIData;
    protected $id = 'memoryGraph';
    protected $name = 'memoryGraph';
    protected $graphSettingsEnabled = true;
    protected $graphSettingsKey = 'cpuGraphSettings';

    public function initContent()
    {
        $selectScope = new Select('timeframe');
        $selectScope->setAvailableValues([
            'hour' => 'Hour',
            'day'  => 'Day',
            'week' => 'Week',
            'year' => 'Year',
        ]);
        $selectScope->setDefaultValue('week');
        $this->addSettingField($selectScope);

        $this->updateChartScale('yAxes', [
            [
                'scaleLabel' => [
                    'display'     => true,
                    'labelString' => 'Bytes/s'
                ],
                'ticks'      => [
                    'callback' => 'mgBytesToSize'
                ],
            ]]);

        $this->updateChartOption('tooltips', [
            'callbacks' => [
                'label' => 'mgTooltipCallbackForMemory'
            ]
        ]);
    }

    public function prepareAjaxData()
    {
        if ($this->configChartsSettings->timeframe)
        {
            $this->timeframe = $this->configChartsSettings->timeframe;
        }
        $rrdata = main\Core\Helper\DatabaseCache::loadData(
            $this->graphSettingsKey.$this->timeframe . '_cacheData', [$this, 'loadApiData'], 30, true);

        $labels     = [];
        $dataSets   = [
            'memused' => [],
            "memtotal"  => [],
        ];
        $dateFormat = in_array($this->timeframe, ['hour', 'day']) ? "H:i:s" : "Y-m-d";
        foreach ($rrdata as $rrd)
        {
            $labels[] = date($dateFormat, $rrd['time']);
            $dataSets['memused'][]    = (float)$rrd['memused'];
            $dataSets['memtotal'][] = (float)$rrd['memtotal'];

        }
        //Labels
        $this->setLabels($labels);
        //Memory
        $lang    = main\Core\ServiceLocator::call('lang');
        $dataSet = new DataSet();
        $dataSet->setTitle($lang->absoluteT('Memory Usage'))
            ->setData($dataSets['memused'])
            ->setConfigurationDataSet([
                "backgroundColor" => 'rgba(39, 133, 134, 0.91)',
                "borderColor"     => 'rgba(39, 133, 134, 1)',
            ]);
        $this->addDataSet($dataSet);
        //Total
        $dataSet = new DataSet();
        $dataSet->setTitle($lang->absoluteT('Total'))
            ->setData($dataSets['memtotal'])
            ->setConfigurationDataSet([
                "backgroundColor" => 'rgba(174, 198, 57, 0.79)',
                "borderColor"     => 'rgba(174, 198, 57, 1)',
            ]);
        $this->addDataSet($dataSet);
    }
}
